Subject: bug#63711: 30.0.50; Crash in xdisp.c when it->string is 0x0

From: Eli Zaretskii <[email-masked]>
Date: Thu, 25 May 2023 18:54:13 +0300

> From: Thomas Fitzsimmons <[email-masked]>
> Cc: [email-masked]
> Date: Thu, 25 May 2023 11:25:23 -0400
> 
> >   (gdb) prow
> 
> y=701 x=0 pwid=1287 a+d=18+5=23 phys=16+4=20 vis=23
> used=(LMargin=0,Text=113,RMargin=0) Hash=258184180
> start=0 end=0 ENA MODEL
> 
> >   (gdb) pgrow
> 
> TEXT: 113 glyphs
>   0    0: CHAR[ ] str=0xf188ab16[0] blev=0,btyp=L w=11 a+d=18+5 face=1
>   1   11: CHAR[U] str=0x1ccec60[1] blev=0,btyp=L w=11 a+d=18+5 face=1
>   2   22: CHAR[:] str=0x4e125d0[0] blev=0,btyp=L w=11 a+d=18+5 face=1
>   3   33: STRETCH[23+18] str=0x1ccecb8[0] w=33 a+d=18+5 face=1
>   4   66: CHAR[@] str=0x1ccecb8[0] blev=0,btyp=L w=11 a+d=18+5 face=1

This is the mode line: first sign of trouble.  We are handling a
mode-line glyph row as if it were a text row.  That cannot lead to
anything good, ever.

> >   (gdb) p first_reusable_row - start_row
> 
> $22 = 15
> 
> >   (gdb) p first_row_to_display - start_row
> 
> $23 = 30

So we think that the first glyph row to display is screen line 30
(zero-based).  Is it true that the window was supposed to have only 30
lines in its body, not 31?

> >   (gdb) p first_row_to_display->y
> 
> $24 = 701
> 
> >   (gdb) p window_text_bottom_y(w)
> 
> $25 = 701

And this also tells us that we are using the wrong glyph row, I think:
its Y coordinate is outside of the visible text area.

I think I understand the problem.  Let me think about a solution.
Please leave this GDB session running, in case I'll need some more
data from it.

> > But there weren't supposed to be any overlays at the beginning of the
> > buffer, right?
> 
> Correct, there weren't supposed to be any overlays at the beginning of
> the buffer -- as far as I know, anyway.  I didn't explicitly do anything
> with overlays.

The window doesn't display the beginning of the buffer, it displays
starting at buffer position 142803, see the glyphs of start_row.  The
zero position we get in pos->pos.charpos is because that's a position
of the string from which the mode line was generated.

> > Can you describe your experiments with font-locking JavaScript?  Which
> > display-related features did you try?
> 
> I was enabling and disabling font-lock-mode, running font-lock-ensure
> and font-lock-flush on temporary buffers (not in the js.el buffer).  I
> wasn't doing anything particularly fancy or low-level, just elisp-level
> function calls and changing font-lock variable settings, primarily the
> js keyword variables.

OK.